                                PROGRAM

                                MAP
                                END ! map

                                INCLUDE('OCRClass.Def'),ONCE
                                INCLUDE('OCRClass.Inc'),ONCE

eINIFileName                    EQUATE('.\ocr_test.ini')
eINISection                     EQUATE('ocr_test')
eMessageTitle                   EQUATE('OCR Test')

bDictionaryOK                   BYTE               ! dictionary ok flag
bErrorLevel                     BYTE               ! error level
bLanguage                       BYTE               ! language
bLoadSingleImage                BYTE               ! load single image flag
bProgress                       BYTE               ! progress percent
bReduceNoise                    BYTE               ! reduce noise flag

sDictDir                        STRING(255)        ! dictionary directory
sInputFile                      STRING(255)        ! input file
sOutputText                     STRING(10001)      ! output text
sSaveDictDir                    LIKE(sDictDir)     ! save dictionary directory

oOCR                            cOCR

Window WINDOW('OCR Test'),AT(,,456,260),FONT('MS Sans Serif',8,,FONT:regular),CENTER,SYSTEM,GRAY,MAX, |
         DOUBLE
       BUTTON('&Select Image File'),AT(8,5,68,15),USE(?SelectFile:Button)
       STRING(@s255),AT(79,8,357,10),USE(sInputFile),FONT(,,COLOR:Blue,,CHARSET:ANSI)
       PROMPT('L&anguage:'),AT(8,24),USE(?bLanguage:Prompt)
       LIST,AT(76,24,60,10),USE(bLanguage),FORMAT('80L(2)|M@s20@'),DROP(10),FROM('None|#0|English|#1|French|#2|Dutch|#3|EngUK|#4|Custom|#5')
       PROMPT('D&ictionary Directory:'),AT(8,37),USE(?sDictDir:Prompt)
       ENTRY(@s255),AT(76,37,358,10),USE(sDictDir),FONT(,,COLOR:Blue,,CHARSET:ANSI)
       BUTTON('...'),AT(436,37,12,10),USE(?sDictDir:Button),SKIP
       TEXT,AT(8,56,341,183),USE(sOutputText),BOXED,VSCROLL
       CHECK(' &Load Single Image'),AT(355,56),USE(oOCR.bLoadSingleImage)
       CHECK(' &Deskew Image'),AT(355,67),USE(oOCR.bDeskewImage)
       CHECK(' &Reduce Noise'),AT(355,78),USE(oOCR.bReduceNoise)
       CHECK(' &Erase Black Borders'),AT(355,89),USE(oOCR.bEraseBlackBorders)
       CHECK(' &Copy Output To Clipboard'),AT(355,100),USE(oOCR.bOutputToClipboard)
       CHECK(' &Trace'),AT(355,111),USE(oOCR.bTraceOn)
       BUTTON('&Image Info'),AT(365,202,75,15),USE(?ImageInfo:Button)
       BUTTON('C&onvert To Text'),AT(365,219,75,15),USE(?OCR:Button)
       BUTTON('&Close'),AT(365,236,75,15),USE(?Close:Button)
       PROGRESS,USE(bProgress),AT(8,242,341,8),RANGE(0,100)
     END

  CODE

  bLanguage               = GETINI(eINISection,'Language'         ,eEnglish             ,eINIFileName)
  sDictDir                = GETINI(eINISection,'DictDir'          ,oOCR.ProgramDir(True),eINIFileName)
  sInputFile              = GETINI(eINISection,'InputFile'        ,''                   ,eINIFileName)
  oOCR.bOutputToClipboard = GETINI(eINISection,'OutputToClipboard','0'                  ,eINIFileName)
  oOCR.bLoadSingleImage   = GETINI(eINISection,'LoadSingleImage'  ,'1'                  ,eINIFileName)
  oOCR.bReduceNoise       = GETINI(eINISection,'ReduceNoise'      ,'1'                  ,eINIFileName)
  oOCR.bDeskewImage       = GETINI(eINISection,'DeskewImage'      ,'1'                  ,eINIFileName)
  oOCR.bEraseBlackBorders = GETINI(eINISection,'EraseBlackBorders','0'                  ,eINIFileName)
  oOCR.bTraceOn           = GETINI(eINISection,'TraceOn'          ,'0'                  ,eINIFileName)
  oOCR.bLanguage          = bLanguage
  oOCR.sDictDir           = sDictDir
  oOCR.lProgressFEq       = ?bProgress
  oOCR.lOutputTextFEq     = ?sOutputText

  OPEN(Window)

  ACCEPT
    CASE EVENT()
    OF EVENT:OpenWindow

    OF EVENT:CloseWindow
      BREAK
    END ! case

    CASE FIELD()
    OF ?Close:Button
      CASE EVENT()
      OF EVENT:Accepted
        POST(EVENT:CloseWindow)
      END ! case

    OF ?SelectFile:Button
      CASE EVENT()
      OF EVENT:Accepted
        IF NOT FILEDIALOG('Pick An Image File To Submit To The OCR Engine.',     |
                          sInputFile,                                            |
                          'Image Files (*.bmp, *.pcx, *.tif)|*.tif;*.bmp;*.pcx', |
                          FILE:KeepDir + FILE:LongName)
          ERASE(?bProgress)
          ERASE(?sInputFile)
        ELSE
          CHANGE(?sInputFile,LOWER(sInputFile))
          ERASE(?bProgress)
          ERASE(?sOutputText)
          PUTINI(eINISection,'InputFile',sInputFile,eINIFileName)
        END ! if
      END ! case

    OF ?OCR:Button
      CASE EVENT()
      OF EVENT:Accepted
        IF EXISTS(sInputFile) = True
          ERASE(?bProgress)
          ERASE(?sOutputText)
          DISPLAY()
          bErrorLevel = oOCR.OCR(sInputFile,0,0)
          IF bErrorLevel ~= LEVEL:Benign
            MESSAGE('An error occurred attempting to convert the selected image to text.||'   & |
                    'The error is: ' & oOCR.GetLastErrNo() & ' - ' & CLIP(oOCR.GetLastError()), |
                    eMessageTitle,ICON:Exclamation)
          END ! if
        ELSE
          MESSAGE('You must select an image file!', |
                  eMessageTitle,ICON:Exclamation)
        END !
      END ! case

    OF ?ImageInfo:Button
      CASE EVENT()
      OF EVENT:Accepted
        IF EXISTS(sInputFile) = True
          bErrorLevel = oOCR.DisplayImageInfo(sInputFile)
        ELSE
          MESSAGE('You must select an image file!', |
                  eMessageTitle,ICON:Exclamation)
        END ! if
      END ! case

    OF ?oOCR:bLoadSingleImage
      CASE EVENT()
      OF EVENT:Accepted
        PUTINI(eINISection,'LoadSingleImage',oOCR.bLoadSingleImage,eINIFileName)
      END ! case

    OF ?oOCR:bReduceNoise
      CASE EVENT()
      OF EVENT:Accepted
        PUTINI(eINISection,'ReduceNoise',oOCR.bReduceNoise,eINIFileName)
      END ! case

    OF ?oOCR:bDeskewImage
      CASE EVENT()
      OF EVENT:Accepted
        PUTINI(eINISection,'DeskewImage',oOCR.bDeskewImage,eINIFileName)
      END ! case

    OF ?oOCR:bEraseBlackBorders
      CASE EVENT()
      OF EVENT:Accepted
        PUTINI(eINISection,'EraseBlackBorders',oOCR.bEraseBlackBorders,eINIFileName)
      END ! case

    OF ?oOCR:bOutputToClipboard
      CASE EVENT()
      OF EVENT:Accepted
        PUTINI(eINISection,'OutputToClipboard',oOCR:bOutputToClipboard,eINIFileName)
      END ! case

    OF ?oOCR:bTraceOn
      CASE EVENT()
      OF EVENT:Accepted
        PUTINI(eINISection,'TraceOn',oOCR.bTraceOn,eINIFileName)
      END ! case

    OF ?bLanguage
      CASE EVENT()
      OF EVENT:Accepted
        PUTINI(eINISection,'Language',bLanguage,eINIFileName)
        oOCR.bLanguage = bLanguage
      END ! case

    OF ?sDictDir
      CASE EVENT()
      OF EVENT:Selected
        sSaveDictDir = sDictDir

      OF EVENT:Accepted
        DO CheckDictionary
        IF bDictionaryOK = False
          CHANGE(?sDictDir,sSaveDictDir)
          SELECT(?sDictDir)
          CYCLE
        END ! if

        PUTINI(eINISection,'DictDir',sDictDir,eINIFileName)
        oOCR.sDictDir = sDictDir
      END ! case

    OF ?sDictDir:Button
      CASE EVENT()
      OF EVENT:Selected
        sSaveDictDir = sDictDir

      OF EVENT:Accepted
        DO GetDictDir
        DO CheckDictionary
        IF bDictionaryOK = False
          CHANGE(?sDictDir,sSaveDictDir)
          SELECT(?sDictDir:Button)
          CYCLE
        END ! if
        PUTINI(eINISection,'DictDir',sDictDir,eINIFileName)
        oOCR.sDictDir = sDictDir
      END ! case
    END ! case
  END ! accept

!----------------------------------------------------------!
! GetDictDir
!----------------------------------------------------------!

GetDictDir                      ROUTINE

  DATA

sSavePath                       STRING(FILE:MaxFilePath)

  CODE

  sSavePath = PATH()

  IF sDictDir ~= ''
    SETPATH(oOCR.RemoveBackSlash(sDictDir))
  END ! if

  Junk# = FILEDIALOG('Select the Dictionary Directory',              |
                     sDictDir,                                       |
                     '',File:KeepDir + File:Directory + File:LongName)

  sDictDir = LOWER(oOCR.AddBackSlash(sDictDir))
  CHANGE(?sDictDir,sDictDir)

  SETPATH(sSavePath)

!----------------------------------------------------------!
! CheckDictionary
!----------------------------------------------------------!

CheckDictionary                 ROUTINE

  DATA

sDictionaryFileName             STRING(FILE:MaxFileName)
sLanguage                       STRING(20)

  CODE

  bDictionaryOK = True

  IF bLanguage ~= 0
    CASE bLanguage
    OF 1;sLanguage = 'English'
    OF 2;sLanguage = 'French'
    OF 3;sLanguage = 'Dutch'
    OF 4;sLanguage = 'EngUK'
    OF 5;sLanguage = 'Custom'
    END ! case

    sDictionaryFileName = CLIP(oOCR.AddBackSlash(sDictDir)) & CLIP(sLanguage) & '.wdc'

    IF NOT EXISTS(sDictionaryFileName)
      BEEP
      BEEP(BEEP:SystemExclamation)
      MESSAGE('The dictionary file: ' & CLIP(sDictionaryFileName) & ' does not exist for '    & |
              'the selected language.||Please select another Language or locate the correct ' & |
              'dictionary file.',eMessageTitle,ICON:Exclamation)
      bDictionaryOK = False
    END ! if
  END ! if

!----------------------------------------------------------!

